/**
 * Arrival section of Enslavement, Night One.
 * @param {CaravanConfinementController} controller The Enslavement, Night One controller.
 */
function CaravanConfinementArrival(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.arrival;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new CaravanConfinementName(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var fucked = global.kobold.history.shared.enslavement.captureFucked;
        var male = ctrl.misc.baseGender() === GenderEnum.MALE;
        var toReturn = `[p]
                            After a long, humiliating walk, the two of you finally arrive back at the money transport.
                            The sun luckily went down about halfway through the trek, darkness somewhat concealing your
                            nudity${fucked ? ` [sneak]and the cum leaking from your still slightly gaping ${male ? `tailhole` : `cunt`}[/sneak]` : ``}.
                            A small campfire along the side of the road illuminates the area.
                            Combined with a couple of torches affixed to the carts themselves, the convoy is lit well enough to scare off any would-be midnight thieves.
                        [/p]
                        [p]
                            While some caravan guards are busy patrolling and standing watch, most of them are seated around the warming flames.
                            The mood is audibly jolly.
                            You aren't even close to them,
                            but you can already [b]reek[/b] the hefty smell of the copious amounts of poorly brewed alcohol they're gulping down.
                            Amongst the group is the human that was chasing you earlier, sitting next to his dog.
                            He is the first to notice the wolf's triumphant return.
                            After a joyous greeting, all eyes turn to you.
                        [/p]
                        [p]
                            While an entire group of unruly, armed and drunken men of various species staring down your naked form is intimidating, to say the least,
                            the worst of your imminent worries are quelled when a more [i]rational looking[/i] fellow emerges from the front of the convoy.
                            It's the caravan master!
                            The [i]one[/i] human around who [i]doesn't[/i] look like he was ripped straight out of a portrait depicting a band of bandits.
                            And, going by his fancy imperial tunic, he's in charge of this whole operation.
                            Surely, one of the king's sergeants won't stand for a [i]drunken gangrape[/i], right?
                        [/p]
                        [p]
                            "[color=brown]So [b]this[/b] is our little [b]thief[/b]?[/color]" the bulky man speaks,
                            adjusting his belt as though to assert his dominance over the wolf.
                            "[color=gblue]Eyup.[/color]" comes the canine's response.
                            "[color=gblue]Caught'em running through the woods. Would have been halfway to Salamar by now, if not for me and Kajar.[/color]"
                            You assume Kajar is the human that was chasing you earlier.
                        [/p]
                        [p]
                            The caravan master casts a glare your way.
                            The hateful stare sends shivers down your spine.
                            "[color=brown]And what about the money?
                            Did you get it back, or are we having kobold meat for dinner?[/color]"
                            He practically [b]spits[/b] out the world [i]kobold[/i], his voice heavy with disdain.
                        [/p]
                        [p]
                            The canine pats his pocket, rattling the hoard of coins contained within.
                            A smug smile forms on his face.
                            He's holding all of the cards in the palm of his hand, and he knows it.
                            "[color=gblue]Two conditions.[/color]"
                            The human is clearly irked, his head jerking to face the lupine once more.
                            "[color=brown][b]Conditions?![/b]
                            You work for me!
                            Now hand over the bloody coin, or I'll have your entire gang of misfits [b]beheaded[/b]![/color]"
                        [/p]
                        [p]
                            The wolf seems unfazed by the caravan master's threat.
                            Once again, he repeats himself, a little louder.
                            "[color=gblue][b]Two. Conditions.[/b][/color]"
                            Not interrupted by his superior this time around, the canine states his terms.
                            "[color=gblue]Double pay for me and Kajar.
                            Ontop of that, I get the lizard.[/color]"
                            Grabbing you by the side of your head, the furred bandit tugs your head towards his clothed groin,
                            holding you close to him, flaunting his [i]ownership[/i].
                        [/p]
                        [p]
                            The human takes a moment to consider his options.
                            "[color=brown]Fine, double your [b]measly[/b] pay.[/color]"
                            Reaching for your metal collar, the caravan master firmly [b]yanks[/b] you towards him,
                            tearing you from the lupine's grasp.
                            "[color=brown]But the kobold is [b]mine[/b] by law.
                            It stole from [b]me[/b], not [b]you[/b].[/color]"
                        [/p]
                        [p]
                            The lupine chuckles.
                            "[color=gblue]Law?
                            We may be close, but we're not in Varanar yet.
                            The only [b]law[/b] in these woods is that the guy with the biggest gang gets what he wants.
                            And right now, that guy just happens to be [b]me[/b].[/color]"
                            The wolf bares his teeth.
                            The human grits his.
                            They glare at one another.
                            A small standoff ensues.
                            Tension is tangibly rising.
                        [/p]
                        [p]
                            "[color=brown]Half.[/color]"
                            the caravan master speaks, breaking the unnerving silence.
                            "[color=brown]I get two tries to sell it.
                            Once at the hamlet, once in the city proper.
                            You get half of whatever people are willing to pay for this [b]miserable[/b] excuse of a [b]thief[/b].[/color]"
                            The wolf narrows his eyes.
                            "[color=gblue]And if you can't sell'em?[/color]"
                        [/p]
                        [p]
                            "[color=brown]A kobold that doesn't sell is [b]useless[/b] to me.
                            If nobody wants it, it'll be yours to keep.[/color]"
                            The wolf's turn to ponder his choices.
                            After exchanging angry stares for a few more harrowing seconds, he replies:
                            "[color=gblue]Deal,
                            but if you [b]dare[/b] doublecross us, neither the baron, nor the king himself will be able to save your sorry ass.[/color]"
                            The human snickers.
                            "[color=brown]Unlike you [b]thugs[/b], I am a man of my word.[/color]"
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.applyTheme("forest_night");
        ctrl.bgm.loop();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
