/**
 * Help section of the bandit encounter.
 * @param {ForestController} controller The forest controller.
 */
function ForestBanditHelp(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;
    
    var continueId = "banditHelpContinueButton";
    
    var content = ` <div class="text">
                        After waiting for a few more moments to ensure the gang of kobolds has left completely,
                        you emerge from your hiding spot, and slowly approach the dragoness.
                        The thick smell of 
                        ${(ctrl.bandit.watch.getHelpSource() === ForestBanditHelpSourceEnum.INDULGE) ? "four" : "five"} combined loads of hefty kobold spunk hits your sensitive nose like a truck.
                        You can only imagine how she must be feeling.
                    </div>
                    <div class="text">
                        You kneel down next to the woman, and gently put your hand on the top of her head
                        You calmly pat her head in an effort to comfort her, making sure to avoid the large amount of cum sticking to her scales.
                        She doesn't acknowledge you, continuing to stare blankly up at the sky, her jaw slightly agape.
                        You utter some comforting words, yet much like your patting, you doubt they have much effect.
                    </div>
                    <div class="text">
                        You try to keep a smile on your face to appear more amicable than the other kobolds,
                        but you can't help but frown at the state the mentally broken state the dragoness is in.
                        You decide to go about things a different way.
                        You pick up the woman's discarded, used underwear.
                        It's disgusting and sticky, but you bear with it.
                        Bringing the rag to her still-spread legs, you press it against her cum-leaking slit, 
                        and carefully clean the slightly gaping orifice, the silk fabric soaking up much of the jizz spilling from her folds.
                    </div>
                    <div class="text">
                        With her groin at least <span class="italic">somewhat</span> devoid of spunk, you set yourself to the task of closing her legs.
                        You strain yourself to lift one of the large, blue appendages, and bring it just a little bit closer to the other.
                        Then, you repeat the process for the second leg, improving her posture from spread-eagle whore to naked, catatonic damsel.
                    </div>
                    <div class="text">
                        She can't stay here.
                        It's dangerous out in the woods.
                        There's other bandits, woodland creatures and even some <span class="italic">slavers</span> that might find her.
                        You call out for her, try to get her to snap back to reality, yet nothing seems to work.
                        Slightly frustrated, you take hold of her arm, and pull it upwards, in an attempt to get her to sit upright.
                        Still no response.
                    </div>
                    <div class="text">
                        You sigh loudly.
                        There isn't much you can do for her without her cooperation.
                        Still, you can't just leave her out here.
                        Then, an idea crosses your mind.
                        The leaves.
                        You can use the leaves!
                        Picking up a few handfuls of them, you strew them about the unresponsive dragoness' body, 
                        camouflaging her blue scales with far more natural brown and yellow colors.
                    </div>
                    <div class="text">
                        You rise to your feet.
                        While not really satisfied with your work, you did the best you could.
                        You restored some of the dragoness' dignity, and you gave her some camouflage to prevent her from getting found by people who are <span class="italic">less kind</span> than you are.
                    </div>
                    <div class="text">
                        You try one final time to <span class="italic">get through</span> to her, without success.
                        While you'd love to stay and watch over the woman, you'd just end up attracting more attention, especially with the pouch of money strapped around your neck.
                        Besides, a single lone kobold like yourself wouldn't be able to offer her much protection anyway.
                        Despite your childhood dreams, you <span class="bold">aren't</span> a knight in shining armor.
                    </div>
                    <div class="text">
                        With a sigh, you wave the dragoness goodbye, before walking out of the clearing.
                        You head home, hoping she'll be alright. 
                        In the end, you did the right thing. 
                        But you can't help but feel a little guilty for not even <span class="bold">trying</span> to stop the gang.
                    </div>`;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.bandit.watch.helpHasContinued();
        var choice = `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        return choice;
    }
    
    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }
    
    /**
     * Loads and displays the next part.
     */
    function loadNextPart() {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(ctrl.homeSceneName);
        });
    }
    
    /**
     * Adds a listener to the continue button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.watch.helpContinue();
            loadNextPart();
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "banditHelp";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (!ctrl.bandit.watch.hasHelpSource()) {
            return "";
        }
        ctrl.bandit.watch.helpShared();
        var status = ctrl.bandit.watch.helpStatus();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += content;
        part += status;
        part += buildChoice();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (!ctrl.bandit.watch.hasHelpSource()) {
            return;
        }

        // Register child listeners here

        if (ctrl.bandit.watch.helpHasContinued()) {
            return;
        }

        registerContinueListener();
    };
}

/**
 * Source for the help part of the bandit encounter.
 */
var ForestBanditHelpSourceEnum = {
    MASTURBATE: 1,
    KEEPWATCHING: 2,
    INDULGE: 3
};
